var https = require('https');
var os = require('os');
var http = require('http');
var url = require('url');
var fs = require('fs');
var path = require('path');
var stream = require('stream');
var configJSON = JSON.parse(fs.readFileSync("config.json")); //Read configuration JSON
function Mod() {}
Mod.prototype.callback = function callback(req, res, serverconsole, responseEnd, href, ext, uobject, search, defaultpage, users, page404, head, foot, fd, elseCallback) {
    return function() {
        var aheaders = configJSON.customHeaders; //Headers
        aheaders["Content-Type"] = 'text/html' //HTML output
        aheaders["Server"] = 'SVR.JS/' + configJSON.version + ' (' + os.platform()[0].toUpperCase() + os.platform().slice(1) + ')'; //Add Server header
        //*********************
        //*RedBrick CGI Engine*
        //*********************
        function executeCGISync(fname) {
            var exttointerepter = {
                ".pl": ["perl"],
                ".py": ["python"],
                ".sh": ["bash"],
                ".ksh": ["ksh"],
                ".csh": ["csh"],
                ".js": ["node"],
                ".bat": ["cmd", "/c"],
                ".cmd": ["cmd", "/c"],
                ".vbs": ["cscript"],
                ".jar": ["java"],
                ".pyo": ["python"],
                ".rb": ["ruby"]
            }
            var fs = require('fs');
            var path = require('path');
            var script = fs.readFileSync(fname).toString();
            var fl = script.replace(/\r/g, "\n").split("\n")[0];
            if (fl[0] == undefined) fl[0] = "";
            var ext = path.extname(fname);
            var args = [];
            var buffer = "";
            var headerendline = -1;
            var cned = false;
            var tempID = Math.random()
            args.push(fname);
            if (fl.indexOf("#!") == 0) {
                args = fl.substr(2).split(" ");
                var lns = script.replace(/\r\n/g, "\n").replace(/\r/g, "\n").split("\n");
                lns.shift();
                fs.writeFileSync("./temp/" + tempID, lns.join(require("os").EOL));
                fname = "./temp/" + tempID;
                args.push(fname);
                filename = args.shift();
            } else {
                args = exttointerepter[ext];
                args.push(fname);
                filename = args.shift();
            }
            var {
                spawnSync
            } = require('child_process');
            var stdout = spawnSync(filename, args).stdout.toString();
            var stdouta = stdout.split(require("os").EOL.repeat(2));
            stdouta.shift();
            stdout = stdouta.join(require("os").EOL.repeat(2))
            return stdout;
        }
        //******************
        //*Berno SSI Engine*
        //******************
        function parseDateString(str, date) {
            var nstr = str;
            var daysAbbr = ['Sun', 'Mon', 'Tue', 'Wed', 'Thu', 'Fri', 'Sat'];
            var dayNameAbbr = daysAbbr[date.getDay()];
            var days = ['Sunday', 'Monday', 'Tuesday', 'Wednesday', 'Thursday', 'Friday', 'Saturday'];
            var dayName = days[date.getDay()];
            const monthNamesAbbr = ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"];
            var monthNameAbbr = monthNamesAbbr[date.getMonth()];
            const monthNames = ["January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"];
            var monthName = monthNames[date.getMonth()];
            var hours = date.getHours();
            var ampm = hours >= 12 ? 'PM' : 'AM';
            var hours12 = hours % 12;
            hours12 = hours12 ? hours12 : 12; // the hour '0' should be '12'
            var dStart = new Date(date.getFullYear(), 0, 0);
            var dDiff = date - dStart;
            var dOneDay = 1000 * 60 * 60 * 24;
            var dayOfYear = Math.floor(dDiff / dOneDay);

            function getWeekNumSunday(date) {
                var dateDelay = date.getDay();
                var nd = new Date(date.getFullYear(), 0, 0);
                dateDelay -= nd.getDay();
                var dStart = new Date(date.getFullYear(), 0, 0);
                var dDiff = date - dStart;
                var dOneDay = 1000 * 60 * 60 * 24;
                var dayOfYear = Math.floor(dDiff / dOneDay);
                dayOfYear -= dateDelay;
                return Math.round(dayOfYear / 7) + 1;
            }

            function getWeekDayMondayFirst(date) {
                var x = date.getDay();
                x++;
                if (x == 7) x = 0;
                return x;
            }

            function getWeekNumMonday(date) {
                var dateDelay = getWeekDayMondayFirst(date);
                var nd = new Date(date.getFullYear(), 0, 0);
                dateDelay -= getWeekDayMondayFirst(nd);
                var dStart = new Date(date.getFullYear(), 0, 0);
                var dDiff = date - dStart;
                var dOneDay = 1000 * 60 * 60 * 24;
                var dayOfYear = Math.floor(dDiff / dOneDay);
                dayOfYear -= dateDelay;
                return Math.round(dayOfYear / 7) + 1;
            }
            nstr = nstr.replace(/%%/g, "\"dpercent\"");
            nstr = nstr.replace(/%a/g, dayNameAbbr);
            nstr = nstr.replace(/%A/g, dayName);
            nstr = nstr.replace(/%b/g, monthNameAbbr);
            nstr = nstr.replace(/%B/g, monthName);
            nstr = nstr.replace(/%c/g, date.toLocaleString());
            nstr = nstr.replace(/%C/g, date.toString());
            nstr = nstr.replace(/%d/g, date.getDate().toString());
            //%D = %m/%d/%y
            nstr = nstr.replace(/%D/g, "0".repeat(2 - (date.getMonth() + 1).toString().length) + (date.getMonth() + 1).toString() + "/" + date.getDate().toString() + "/" + "0".repeat(2 - ((date.getFullYear() % 100).toString().length)) + (date.getFullYear() % 100).toString());
            nstr = nstr.replace(/%e/g, "0".repeat(2 - (date.getDate().toString().length)) + date.getDate().toString());
            nstr = nstr.replace(/%H/g, "0".repeat(2 - hours.toString().length) + hours.toString());
            nstr = nstr.replace(/%h/g, monthNameAbbr);
            nstr = nstr.replace(/%I/g, "0".repeat(2 - hours12.toString().length) + hours12.toString());
            nstr = nstr.replace(/%j/g, "0".repeat(3 - dayOfYear.toString().length) + dayOfYear.toString());
            nstr = nstr.replace(/%m/g, "0".repeat(2 - (date.getMonth() + 1).toString().length) + (date.getMonth() + 1).toString());
            nstr = nstr.replace(/%M/g, "0".repeat(2 - (date.getMinutes()).toString().length) + (date.getMinutes()).toString());
            nstr = nstr.replace(/%n/g, "\n");
            nstr = nstr.replace(/%p/g, ampm);
            nstr = nstr.replace(/%r/g, "0".repeat(2 - hours12.toString().length) + hours12.toString() + ":" + "0".repeat(2 - (date.getMinutes()).toString().length) + (date.getMinutes()).toString() + ":" + "0".repeat(2 - (date.getSeconds().toString().length)) + date.getSeconds().toString() + " " + ampm);
            nstr = nstr.replace(/%R/g, "0".repeat(2 - hours.toString().length) + hours.toString() + ":" + "0".repeat(2 - (date.getMinutes()).toString().length) + (date.getMinutes()).toString());
            nstr = nstr.replace(/%S/g, "0".repeat(2 - (date.getSeconds().toString().length)) + date.getSeconds().toString());
            nstr = nstr.replace(/%t/g, "\t");
            nstr = nstr.replace(/%T/g, "0".repeat(2 - hours.toString().length) + hours.toString() + ":" + "0".repeat(2 - (date.getMinutes()).toString().length) + (date.getMinutes()).toString() + ":" + "0".repeat(2 - (date.getSeconds().toString().length)) + date.getSeconds().toString());
            nstr = nstr.replace(/%U/g, "0".repeat(2 - (getWeekNumSunday(date).toString().length)) + getWeekNumSunday(date).toString());
            nstr = nstr.replace(/%w/g, date.getDay().toString());
            nstr = nstr.replace(/%W/g, "0".repeat(2 - (getWeekNumMonday(date).toString().length)) + getWeekNumMonday(date).toString());
            nstr = nstr.replace(/%x/g, date.toLocaleDateString());
            nstr = nstr.replace(/%X/g, date.toLocaleTimeString());
            nstr = nstr.replace(/%y/g, "0".repeat(2 - ((date.getFullYear() % 100).toString().length)) + (date.getFullYear() % 100).toString());
            nstr = nstr.replace(/%Y/g, "0".repeat(4 - ((date.getFullYear()).toString().length)) + (date.getFullYear()).toString());
            nstr = nstr.replace(/%z/g, Intl.DateTimeFormat().resolvedOptions().timeZone);
            nstr = nstr.replace(/%Z/g, Intl.DateTimeFormat().resolvedOptions().timeZone);
            nstr = nstr.replace(/\"dpercent\"/g, "%%");
            return nstr;
        }

        function executeSSI(shtml, uri, req, res, pubip, port) {
            process.env["QUERY_STRING"] = uri.split("?")[1];
            if (process.env["QUERY_STRING"] == undefined || process.env["QUERY_STRING"] == "undefined") process.env["QUERY_STRING"] = "";
            process.env["SERVER_SOFTWARE"] = "SVR.JS/" + configJSON.version + " (" + os.platform()[0].toUpperCase() + os.platform().slice(1) + '; Node.JS/' + process.version + ") Berno/1.1.0 RedBrick/1.0.0";
            process.env["SERVER_PROTOCOL"] = "HTTP/" + req.httpVersion;
            process.env["SERVER_PORT"] = port;
            process.env["SERVER_ADDR"] = pubip;
            process.env["SERVER_NAME"] = req.headers.host;
            process.env["DOCUMENT_ROOT"] = __dirname;
            process.env["REQUEST_METHOD"] = req.method;
            process.env["REQUEST_URI"] = uri;
            process.env["REMOTE_ADDR"] = res.socket.remoteAddress;
            process.env["REMOTE_PORT"] = res.socket.remotePort;
            process.env["SCRIPT_NAME"] = uri.split("?")[0];
            process.env["SCRIPT_FILE_NAME"] = (__dirname + (require("os").platform == "win32" ? uri.split("?")[0].replace(/\//g, "\\") : uri.split("?")[0])).replace((require("os").platform == "win32" ? /\\\\/g : /\/\//g), (require("os").platform == "win32" ? "\\" : "/"));
            process.env["CONTENT_TYPE"] = req.headers["content-type"];
            process.env["CONTENT_LENGTH"] = req.headers["content-length"];
            process.env["HTTP_ACCEPT"] = req.headers["accept"];
            process.env["HTTP_ACCEPT_CHARSET"] = req.headers["accept-charset"];
            process.env["HTTP_ACCEPT_ENCODING"] = req.headers["accept-encoding"];
            process.env["HTTP_ACCEPT_LANGUAGE"] = req.headers["accept-language"];
            process.env["HTTP_CONNECTION"] = req.headers["connection"];
            process.env["HTTP_COOKIE"] = req.headers["cookie"];
            process.env["HTTP_HOST"] = req.headers["host"];
            process.env["HTTP_USER_AGENT"] = req.headers["user-agent"];

            function sizify(x) {
                if (x < 1000) return x.toString();
                if (x < 10000) return (Math.round(x / 10) / 100).toString() + "K";
                if (x < 100000) return (Math.round(x / 100) / 10).toString() + "K";
                if (x < 1000000) return (Math.round(x / 1000)).toString() + "K";
                if (x < 10000000) return (Math.round(x / 10000) / 100).toString() + "M";
                if (x < 100000000) return (Math.round(x / 100000) / 10).toString() + "M";
                if (x < 1000000000) return (Math.round(x / 1000000)).toString() + "M";
                if (x < 10000000000) return (Math.round(x / 10000000) / 100).toString() + "G";
                if (x < 100000000000) return (Math.round(x / 100000000) / 10).toString() + "G";
                if (x < 1000000000000) return (Math.round(x / 1000000000)).toString() + "G";
                if (x < 10000000000000) return (Math.round(x / 10000000000) / 100).toString() + "T";
                if (x < 100000000000000) return (Math.round(x / 100000000000) / 10).toString() + "T";
                return (Math.round(x / 1000000000000)).toString() + "T";
            }
            var fs = require("fs");
            var begtag = "<!--"
            var endtag = "-->"
            var timeFmt = "%c";
            var echoError = "[Env value undefined]";
            var error = "[Error when executing directive]";
            var bytes = true;
            var directives = []
                //var properties = {}
            for (var i = 0; i != -1;) {
                var t = shtml.indexOf(begtag, i) + begtag.length;
                if (t == begtag.length - 1) break;
                var e = shtml.indexOf(endtag, t);
                if (e == -1) break;
                directives.push({
                    cont: shtml.substring(t, e),
                    org: shtml.substring(t - begtag.length, e + endtag.length),
                    revoked: false
                })
                i = e + 1
            }
            for (var i = 0; i < directives.length; i++) {
                var directive = (directives[i].cont);
                while (directive[0] == " ") {
                    directive = directive.substr(1)
                }
                while (directive[directive.length - 1] == " ") {
                    directive = directive.substr(0, directive.length - 1)
                }
                var dtable = {};
                if (directive[0] !== "#") {
                    directives[i].revoked = true;
                } else {
                    dtable.directive = directive.split(" ")[0].substr(1);
                    //console.log(dtable.directive);
                    var properties = {};
                    if (dtable.directive.length + 1 < directive.length) {
                        var dproperty = false;
                        var cindex = dtable.directive.length + 1;
                        try {
                            while (!dproperty) {
                                var ciold = cindex
                                for (var j = ciold; j < directive.length; j++) {
                                    if (directive[j] != " ") break;
                                    cindex++;
                                }
                                var substr = directive.substr(cindex);
                                var equ = substr.indexOf("=");
                                var varname = substr.substring(0, equ);
                                //console.log(varname)
                                var parsed = false;
                                var y = 1;
                                while (!parsed) {
                                    var x = substr.substr(equ + 2);
                                    var sep = substr.substr(equ + 1, 1);
                                    var q = x.indexOf(sep, y);
                                    if (q != x.indexOf("\\" + sep, y) + 1) {
                                        //console.log(sep + x.substr(0, q) + sep + ";");
                                        properties[varname] = eval(sep + x.substr(0, q) + sep + ";");
                                        cindex += q + varname.length + 4
                                        parsed = true;
                                    } else {
                                        y = q;
                                    }
                                }
                                //console.log(substr.substr(equ+1))
                                //console.log(JSON.stringify(properties))
                                if (cindex >= directive.length) dproperty = true;
                            }
                        } catch (ex) {
                            throw new Error("SSI Parse Error");
                        }
                    }
                    dtable.properties = properties;
                    directives[i].metadata = dtable;
                }
            }
            //console.log("pik ekse")
            var dindex = 0;
            for (var i = 0; i < directives.length; i++) {
                dindex = shtml.indexOf(directives[i].org, dindex);
                var result = "";
                if (directives[i].revoked) {
                    dindex += directives[i].org.length + 1;
                } else {
                    try {
                        if (directives[i].metadata.directive == "include") {
                            if (directives[i].metadata.properties.virtual) {
                                if (require("path").extname(directives[i].metadata.properties.virtual) == ".cgi") {
                                    result = "[No support for CGI scripts in include directive]";
                                } else {
                                    result = fs.readFileSync("." + uri + directives[i].metadata.properties.virtual);
                                }
                            } else {
                                if (require("path").extname(directives[i].metadata.properties.file) == ".cgi") {
                                    result = "[No support for CGI scripts in include directive]";
                                } else {
                                    result = fs.readFileSync("./" + directives[i].metadata.properties.file);
                                }
                            }
                        } else if (directives[i].metadata.directive == "exec") {
                            if (directives[i].metadata.properties.cgi) {
                                result = executeCGISync("." + directives[i].metadata.properties.cgi.split("?")[0]);
                            } else {
                                result = require("child_process").execSync(directives[i].metadata.properties.cmd).toString().replace(/ /g, "&nbsp;").replace(/\n/g, "<br/>");
                            }
                        } else if (directives[i].metadata.directive == "echo") {
                            if (directives[i].metadata.properties.var == "DATE_LOCAL") {
                                result = parseDateString(timeFmt, new Date());
                            } else if (directives[i].metadata.properties.var == "DATE_GMT") {
                                result = parseDateString(timeFmt, new Date(new Date().toUTCString()));
                            } else {
                                result = process.env[directives[i].metadata.properties.var];
                                if (result == undefined) result = echoError;
                                else result = result.toString();
                            }
                        } else if (directives[i].metadata.directive == "config") {
                            if (directives[i].metadata.properties.timefmt !== undefined) timeFmt = directives[i].metadata.properties.timefmt;
                            if (directives[i].metadata.properties.sizefmt !== undefined) {
                                if (directives[i].metadata.properties.sizefmt == "abbrev") bytes = false
                                else if (directives[i].metadata.properties.sizefmt == "bytes") bytes = true;
                                else throw new Error("Invalid value");
                            }
                            if (directives[i].metadata.properties.echomsg !== undefined) echoError = directives[i].metadata.properties.echomsg;
                            if (directives[i].metadata.properties.errmsg !== undefined) error = directives[i].metadata.properties.errmsg;
                        } else if (directives[i].metadata.directive == "flastmod") {
                            if (directives[i].metadata.properties.virtual) {
                                result = parseDateString(timeFmt, fs.lstatSync("." + uri + directives[i].metadata.properties.virtual).mtime);
                            } else {
                                result = parseDateString(timeFmt, fs.lstatSync(directives[i].metadata.properties.file).mtime);
                            }
                        } else if (directives[i].metadata.directive == "fsize") {
                            if (directives[i].metadata.properties.virtual) {
                                if (bytes) result = fs.lstatSync("." + uri + directives[i].metadata.properties.virtual).size;
                                else result = sizify(fs.lstatSync("." + uri + directives[i].metadata.properties.virtual).size);
                            } else {
                                if (bytes) result = fs.lstatSync(directives[i].metadata.properties.file).size;
                                else result = sizify(fs.lstatSync(directives[i].metadata.properties.file).size);
                            }
                        } else if (directives[i].metadata.directive == "set") {
                            process.env[directives[i].metadata.properties.var] = directives[i].metadata.properties.value
                        } else {
                            result = error;
                        }
                    } catch (ex) {
                        result = error;
                    }
                    shtml = shtml.replace(directives[i].org, result.toString());
                    dindex += result.toString().length
                }
            }
            shtml += "<!-- Powered by Berno, an SSI engine -->";
            return shtml;
        }
        if (fs.existsSync("." + href) && fs.lstatSync("." + href).isDirectory() && fs.existsSync(("." + href + "/index.shtml").replace(/\/\//g, "/"))) {
            href = (href + "/index.shtml").replace(/\/\//g, "/");
            req.url = (href + "?" + search).replace("??", "?");
        } else if (fs.existsSync("." + href) && fs.lstatSync("." + href).isDirectory() && fs.existsSync(("." + href + "/index.shtm").replace(/\/\//g, "/"))) {
            href = (href + "/index.shtm").replace(/\/\//g, "/");
            req.url = (href + "?" + search).replace("??", "?");
        }
        if (ext == "shtml" || ext == "shtm") {
            try {
                if (fs.existsSync("." + href) && fs.lstatSync("." + href).isFile()) {
                    require("https").get("https://api.myip.com", (cres) => {
                        var data = "";
                        cres.on("data", (chunk) => {
                            data += chunk;
                        });
                        cres.on("end", () => {
                            try {
                                var result = executeSSI(head + fs.readFileSync("." + href).toString() + foot, req.url, req, res, JSON.parse(data).ip, (process.argv.join(" ").indexOf("--secure") !== -1 ? configJSON.spubport : configJSON.pubport));
                                res.writeHead(200, "Recieved", aheaders);
                                res.end(result);
                            } catch (ex) {
                                res.writeHead(500, "Internal Server Error", aheaders);
                                res.write("<html><head><title>500 Internal Server Error</title></head><body><h1>500 Internal Server Error</h1><p>A server had unexcepted execption. Below, stack of the error is shown: </p><code>" + ex.stack.replace(/\r\n/g, "<br/>").replace(/\n/g, "<br/>").replace(/\r/g, "<br/>").replace(/ /g, "&nbsp;") + "</code><p>Please contact with developer/administrator of the website.</p><p style=\"font-style: italic; font-weight: normal;\">SVR.JS " + configJSON.version + ' (' + os.platform()[0].toUpperCase() + os.platform().slice(1) + '; Node.JS/' + process.version + ') Berno/1.1.0 RedBrick/1.0.0 ' + (req.headers.host == undefined ? "" : " on " + req.headers.host) + "</p></body></html>");
                                res.end();
                            }
                        });
                    });
                } else {
                    elseCallback(); //Directory Listing
                }
            } catch (ex) {
                res.writeHead(500, "Internal Server Error", aheaders);
                res.write("<html><head><title>500 Internal Server Error</title></head><body><h1>500 Internal Server Error</h1><p>A server had unexcepted execption. Below, stack of the error is shown: </p><code>" + ex.stack.replace(/\r\n/g, "<br/>").replace(/\n/g, "<br/>").replace(/\r/g, "<br/>").replace(/ /g, "&nbsp;") + "</code><p>Please contact with developer/administrator of the website.</p><p style=\"font-style: italic; font-weight: normal;\">SVR.JS " + configJSON.version + ' (' + os.platform()[0].toUpperCase() + os.platform().slice(1) + '; Node.JS/' + process.version + ') Berno/1.1.0 RedBrick/1.0.0 ' + (req.headers.host == undefined ? "" : " on " + req.headers.host) + "</p></body></html>");
                res.end();
            }
        } else {
            elseCallback();
        }
    }
}
module.exports = Mod;
